include \masm32\MasmBasic\MasmBasic.inc	; [url=http://www.masm32.com/board/index.php?topic=12460]download[/url]
include \macros\smplmath\math.inc

.data?
MyReal10	REAL10 ?

.code
main proc
LOCAL fSlvTLS()	; otherwise smplmath says it's not thread-safe
	
	print "exact compare: ",13,10
	.if fEQ(1.01,1.02)
		print "    fEQ( 1.01, 1.02):           equal      (exact)",13,10
	.else
		print "    fEQ( 1.01, 1.02):           not equal  (exact)",13,10
	.endif

	print chr$(13,10)
	print "compare using a threshold factor: ",13,10

	.if faEQ(1.01,1.02)
		print "    faEQ( 1.01, 1.02, 1.0E-2):  equal      (+-1%) ",13,10
	.else
		print "    faEQ( 1.01, 1.02, 1.0E-2):  not equal  (+-1%)",13,10
	.endif

	.if faEQ(1.01,1.02,1.0E-3)
		print "    faEQ( 1.01, 1.02, 1.0E-3):  equal      (+-1 per mille) ",13,10
	.else
		print "    faEQ( 1.01, 1.02, 1.0E-3):  not equal  (+-1 per mille)",13,10
	.endif	
	
	.if faEQ(100.01,100.02,1.0E-3)
		print "    faEQ( 100.01, 100.02, 1.0E-3):  equal      (+-1 per mille) ",13,10
	.else
		print "    faEQ( 100.01, 100.02, 1.0E-3):  not equal  (+-1 per mille)",13,10
	.endif	

	print chr$(13,10), "Same with MasmBasic Fcmp:", 13, 10
	Fcmp FP8(100.01), FP8(100.02), high	; ca REAL8
	.if Zero?
		print "    Fcmp 100.01, 100.02, high:  equal       ",13,10
	.else
		print "    Fcmp 100.01, 100.02, high:  not equal  ",13,10
	.endif
	Fcmp FP8(100.01), FP8(100.02), 5	; ca. five digits
	.if Zero?
		print "    Fcmp 100.01, 100.02, 5:     equal       ",13,10
	.else
		print "    Fcmp 100.01, 100.02, 5:     not equal  ",13,10
	.endif	
	Fcmp FP8(100.01), FP8(100.02), 6	; ca six digits
	.if Zero?
		print "    Fcmp 100.01, 100.02, 6:  equal       ",13,10
	.else
		print "    Fcmp 100.01, 100.02, 6:     not equal  ",13,10
	.endif	
	Fcmp FP8(100.01), FP8(100.02), low	; ca REAL4
	.if Zero?
		print "    Fcmp 100.01, 100.02, low:   equal       ",13,10, 10
	.else
		print "    Fcmp 100.01, 100.02, low:  not equal  ",13,10, 10
	.endif
	test4=12345678	; try taking away the 8...

	print "little test x=sqrt(x/7)^2*28/x (should be exactly 4):", 13, 10, "for x="
	print str$(test4), ":", 13, 10
	void Str$(0)	; initialise some MB routines
	push test4
	push 7
	push 28
	push test4
	fild stack
	pop eax
	fild stack
	pop eax
	fild stack
	pop eax
	fild stack
	pop eax
	deb 4, "FPU", ST(0), ST(1), ST(2), ST(3)	; 
	fdivr	; 4/7=0.57
	fsqrt	; 0.7
	fld st
	fmul	; 4/7
	fmul	; 4/7*28=16
	fdivr	; 16/4=4
	fstp MyReal10
	deb 4, "R10", MyReal10
	Fcmp MyReal10, 4, top
	.if Zero?
		print "4 is 4", 13, 10
	.else
		print "4 is not 4", 13, 10
	.endif
	inkey chr$(13, 10, 10)
	exit
	
main endp
end main

RichMasm options:
OPT_Linker	link	; polink crashes
OPT_Tmp2Asm	1
